zoukankan      html  css  js  c++  java
  • HDU-3661(贪心)

    Problem Description
    In a factory, there are N workers to finish two types of tasks (A and B). Each type has N tasks. Each task of type A needs xi time to finish, and each task of type B needs yj time to finish, now, you, as the boss of the factory, need to make an assignment, which makes sure that every worker could get two tasks, one in type A and one in type B, and, what's more, every worker should have task to work with and every task has to be assigned. However, you need to pay extra money to workers who work over the standard working hours, according to the company's rule. The calculation method is described as follow: if someone’ working hour t is more than the standard working hour T, you should pay t-T to him. As a thrifty boss, you want know the minimum total of overtime pay.
     
    Input
    There are multiple test cases, in each test case there are 3 lines. First line there are two positive Integers, N (N<=1000) and T (T<=1000), indicating N workers, N task-A and N task-B, standard working hour T. Each of the next two lines has N positive Integers; the first line indicates the needed time for task A1, A2…An (Ai<=1000), and the second line is for B1, B2…Bn (Bi<=1000).
     
    Output
    For each test case output the minimum Overtime wages by an integer in one line.
     
    Sample Input
    2 5 4 2 3 5
     
    Sample Output
    4
    思路:
    最优化的问题,由于最近一直在看DP,一开始就好不犹豫的选择了DP,但并没有找到什么合适的解
    那么剩下的选择就是贪心了,策略很简单,就是一个数组从小到大排,另一个从大到小排,然后逐项相加就OK
    关键是策略的证明————
    (1)(凭什么让我和你匹配:与其他可能性的比较)a中的最小和b中的最大匹配,如果二者的和没有超过T那自然最好;而如果超过T了,那么a中其他的项与其匹配自然也会超过T。
    (2)(反证法,如果不和你匹配)若有两组(a0,b0), (a1,b1)满足a0>=a1&&b0>=b1,这两组的得分为max(a0+b0-t,0)+max(a1+b1- t,0) >= max(a0+b1-t,0)+max(a1+b0-t,0)即(a0,b1),(a1,b0)的得分,所以交换b0 b1之后可 以使解更优。(此处借鉴其他博客证法)

    #include <iostream>
    #include <cstdio>
    #include <algorithm>
    using namespace std;
    
    int N,T;
    int A[1007],B[1007];
    int g[1007];
    int tmp;
    int ans;
    
    int cmp(int a,int b)
    {
        return a > b;
    }
    
    int main()
    {
        while(~scanf("%d%d",&N,&T))
        {
            ans = 0;
            for(int i = 1;i <= N;i++)
                scanf("%d",&A[i]);
            for(int i = 1;i <= N;i++)
                scanf("%d",&B[i]);
            sort(A+1,A+N+1);
            sort(B+1,B+N+1,cmp);
            for(int i = 1;i <= N;i++) {
                tmp = A[i]+B[i];
                g[i] = max(0,tmp-T);
                ans += g[i];
            }
            printf("%d
    ",ans);
        }
        return 0;
    }
     
  • 相关阅读:
    Scite 中文支持
    【线段上】简单贪心总结……未完
    Happy new year!
    poj 2960 SNim
    【转】SG函数资料(入门必备)
    poj 2478 Farey Sequence
    Poj 3083 Children of the Candy Corn
    Poj 1077 Eight 八数码
    Poj 1830 开关问题:高斯消元
    关于poj 放苹果
  • 原文地址:https://www.cnblogs.com/immortal-worm/p/4936721.html
Copyright © 2011-2022 走看看